using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

typedef long long ll;

const ll max_n = 200000;
const ll max_a = 1000000000;


int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, max_n, "n");
    ensuref(validator.group() != "1" || n <= 3, "g1: k = %d > 3", n);
    ensuref(validator.group() != "4" || n <= 15, "g4: k = %d > 15", n);
    ensuref(validator.group() != "5" || n <= 1000, "g5: k = %d > 1000", n);
    inf.readEoln();
    vector<int> a(n);
    a[0] = inf.readInt(1, max_a, "a_i");
    for (int i = 1; i < n; ++i) {
        inf.readSpace();
        a[i] = inf.readInt(1, max_a, "a_i");
    }
    ensuref(validator.group() != "2" ||
        *max_element(a.begin(), a.end()) == *min_element(a.begin(),a.end()),
        "g2: min != max");
    ensuref(validator.group() != "3" ||
            *max_element(a.begin(), a.end()) <= 50,
            "g3: max > 50");
    
    inf.readEoln();
    inf.readEof();

    return 0;
}
