#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

struct room {
    int d, a, b;
};

istream &operator>>(istream &in, room &r) {
    return in >> r.b >> r.d >> r.a;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item: v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    in(int, n, m)
    vector<room> lab(n);
    vector<vector<pii>> g(n);
    for (int i = 0; i < n; i++) {
        cin >> lab[i];
        lab[i].b--;
    }
    for (int i = 0; i < n; i++) {
        if (lab[i].b >= 0)
            g[lab[i].b].emplace_back(i, lab[lab[i].b].d - lab[i].d);
    }

    vector<int> order(n);
    iota(all(order), 0);
    sort(all(order), [&](int i, int j) {
        return lab[i].d < lab[j].d;
    });

    vector<map<int, int>> ev(n);
    vector<vector<pll>> pev(n);
    for (int i = 0; i < n; i++) {
        ev[i][lab[i].d] = g[i].size() - 1;
        pev[i].emplace_back(lab[i].a, lab[i].d);
    }
    for (int i: order) {
        for (auto const &p: g[i]) {
            ev[i][pev[p.first].back().second + p.second]--;
        }
        int v = 0;
        for (auto const &p: ev[i]) {
            auto const &prev = pev[i].back();
            ll dt = p.first - prev.second;
            pev[i].emplace_back(prev.first + dt * v, p.first);
            v += p.second;
        }
        pev[i].emplace_back(0, pev[i].back().first + pev[i].back().second);
    }

    for (int i = 0; i < m; i++) {
        in(int, r, x)
        r--;
        if (pev[r][pev[r].size() - 2].first < x) {
            cout << "0\n";
            continue;
        }
        pll loc(x, 0);
        int it = lower_bound(pev[r].begin(), pev[r].end() - 1, loc) - pev[r].begin();

        auto const &after = pev[r][it];
        ll first_phase = after.second - lab[r].d;
        if (it > 0) {
            auto const &before = pev[r][it - 1];
            int v = (after.first - before.first) / (after.second - before.second);
            first_phase = (after.first - x) / v;
        }
        ll ans = first_phase +
                (pev[r][pev[r].size() - 2].second - after.second) +
                (pev[r][pev[r].size() - 2].first - x);
        cout << ans << '\n';
    }

}