#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <set>
#include <queue>
#include <cmath>
#include <numeric>
#include <sstream>
#include <string>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <unordered_set>
#include <limits>
#include <list>
#include <bitset>
#include <random>
#include <cstring>
#include <cassert>
#include <chrono>

#define sz(v) int (v.size())
#define ff first
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(),a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; };
/// Actual code starts here
int n;
const int N = 100005;

void solve() {
    cin >> n;
    vector<int> v(n);
    for (auto &i: v) cin >> i;
    vector<vector<int>> ost(100);
    for (int i = 0; i < n; i++) ost[v[i] % 100].pb(i);
    vector<pair<int, int>> res;
    for (int i = 1; i < 100; i++) {
        while (!ost[i].empty() && !ost[100 - i].empty()) {
            if (i == 50 && ost[i].size() == 1) break;
            int a = ost[i].back();
            int b = ost[100 - i].back();
            ost[i].pop_back();
            ost[100 - i].pop_back();
            res.pb({a, b});
        }
    }
    for (int i = 1; i < 100; i++)
        for (int j = 1; j < 100; j++) {
            if (i + j > 100) {
                while (!ost[i].empty() && !ost[j].empty()) {
                    int a = ost[i].back();
                    int b = ost[j].back();
                    ost[i].pop_back();
                    ost[j].pop_back();
                    res.pb({a, b});
                }
            }
        }
    vector<int> need(n, -1);
    for (auto i: res) {
        need[i.ff] = i.ss;
        need[i.ss] = i.ff;
    }
    vector<bool> used(n);
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        if (need[i] == -1) {
            ans += (v[i] / 100);
            used[i] = true;
        } else {
            ans += (v[i] + v[need[i]]) / 100;
            used[i] = true;
            used[need[i]] = true;
        }
    }
    cout << ans << '\n' << res.size() << '\n';
    for (auto i: res) cout << i.ff + 1 << ' ' << i.ss + 1 << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    freopen("input.txt", "r", stdin);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}