#include <bits//stdc++.h>

#ifndef LOCAL
#define _FORTIFY_SOURCE 0
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("inline")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-funroll-loops")
#pragma GCC optimize("-fwhole-program")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-fstrict-overflow")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-skip-blocks")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("-funsafe-loop-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
#endif

#define ll long long
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define ld long double


const int mod = 1e9 + 9;
const int inf = 1e9 + 1;


using namespace std;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll l, ll r) {
    uniform_int_distribution<ll> range(l, r);
    return range(rng);
}


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &x : arr) {
        in >> x;
    }
    return in;
}


pair<int, int> updMins(int m1, int m2, int x) {
    if (x <= m1) {
        return {x, m1};
    } else {
        return {m1, min(x, m2)};
    }
}


void solve() {
    int n, X;
    cin >> n >> X;
    int min1 = inf, min2 = inf;
    queue<pair<int, int>> order;

    function<void()> scream = [&]() {
        queue<pair<int, int>> newQ;
        int m1 = inf, m2 = inf;
        min1 = inf, min2 = inf;
        while (!order.empty()) {
            auto el = order.front();
            order.pop();
            if (el.second <= m2) {
                newQ.push(el);
                auto t = updMins(min1, min2, el.second);
                min1 = t.first;
                min2 = t.second;
            }
            auto t = updMins(m1, m2, el.second);
            m1 = t.first;
            m2 = t.second;
        }
        order = newQ;
    };

    function<void()> upd = [&]() {
        min1 = inf, min2 = inf;
        queue<pair<int, int>> newQ;
        while (!order.empty()) {
            auto el = order.front();
            order.pop();
            newQ.push(el);
            auto t = updMins(min1, min2, el.second);
            min1 = t.first;
            min2 = t.second;
        }
        order = newQ;
    };

    for (int i = 0; i < n; i++) {
        char c;
        cin >> c;
        if (c == '-') {
            //cerr << "i = " << i << " and size is "<< order.size() << endl;
            cout << order.front().first << "\n";
            order.pop();
            upd();
        } else {
            int ind, p;
            cin >> ind >> p;
            if (p > min2 && (p - min1) * (p - min2) > X) {
                scream();
            } else {
                order.push({ind, p});
                auto t = updMins(min1, min2, p);
                min1 = t.first;
                min2 = t.second;
            }
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}